
;****************************************************************************************

ByteLaden:

		cpi BusTeilnZa,1				;Abfrage an wen gesendet werden soll
		breq BusTeiln1Tra
		cpi BusTeilnZa,2
		breq BusTeiln2Tra
		cpi BusTeilnZa,3
		breq BusTeiln3Tra
		ret

BusTeiln1Tra:
		
		ldi	zl,low(SSDatenTra1*2)		
		ldi	zh,high(SSDatenTra1*2)		
		rjmp ZeigerLadenTra
BusTeiln2Tra:
		ldi	zl,low(SSDatenTra2*2)		
		ldi	zh,high(SSDatenTra2*2)		
		rjmp ZeigerLadenTra
BusTeiln3Tra:
		ldi	zl,low(SSDatenTra3*2)		
		ldi	zh,high(SSDatenTra3*2)		
		rjmp ZeigerLadenTra

ZeigerLadenTra:		
		mov temp1,ByteZa
		dec temp1
		clc
		rol temp1
		add zl,temp1
		clr temp1
		adc zh,temp1
		

		lpm temp1,z+
		lpm zh,z
		mov zl,temp1
		
		ld temp4,z
		
 		ret	

;****************************************************************************************

ByteSpeichern:
		
		
		cpi BusTeilnZa,1						;Abfrage von wem empfangen wird
		breq BusTeiln1Rec
		cpi BusTeilnZa,2
		breq BusTeiln2Rec
		cpi BusTeilnZa,3
		breq BusTeiln3Rec
		
		ret

BusTeiln1Rec:		
		ldi	zl,low(SSDatenRec1*2)		
		ldi	zh,high(SSDatenRec1*2)		
		rjmp ZeigerLadenRec
						
BusTeiln2Rec:		
		ldi	zl,low(SSDatenRec2*2)		
		ldi	zh,high(SSDatenRec2*2)		
		rjmp ZeigerLadenRec
			
BusTeiln3Rec:		
		ldi	zl,low(SSDatenRec3*2)		
		ldi	zh,high(SSDatenRec3*2)
		rjmp ZeigerLadenRec

ZeigerLadenRec:
		
		dec ByteZa
		add zl,ByteZa
		ldi temp1,0
		adc zh,temp1
		inc ByteZa
		
		lpm zl,z
		clr zh
		
		st z,temp4		
		
		ret	
		

;****************************************************************************************

delay1ms:                               ;1ms Pause bei 8MHz
           push temp2
		   push temp1
		   ldi  temp1, 11
WGLOOP0:   ldi  temp2, 255
WGLOOP1:   dec  temp2
           brne WGLOOP1
           dec  temp1
           brne WGLOOP0
		   pop temp1
		   pop temp2
           ret

;**********************************************************************************************
PCaktiv:
		
		
		in temp2,PortC
		lds temp3,SSBitByte

		lds temp1,SSZaPCaktiv
		cpi temp1,0
		breq PCaktivOFF
		dec temp1
		cpi temp1,0
		breq PCaktivOFF

		;sbr temp2,1<<PinPCaktiv
		sbr temp3,1<<BitPCaktiv
		rjmp EndePCaktiv

PCaktivOFF:
		;cbr temp2,1<<PinPCaktiv
		cbr temp3,1<<BitPCaktiv		

EndePCaktiv:
		sts SSBitByte,temp3
		out PortC,temp2
		sts SSZaPCaktiv,temp1
		
			
		ret

		
;************************************************************************************
 TimerLCDBeg:
 		
 		lds temp1,SSZaLCDBegL
		lds temp2,SSZaLCDBegH
		
		ldi temp3,1
		add temp1,temp3		
		clr temp3
		adc temp2,temp3					; Zhler um 1 erhhen
		sts SSZaLCDBegL,temp1
		sts SSZaLCDBegH,temp2		

		cpi temp1,ZaLCDBegLMax
		brne EndeTimerLCDBeg
		cpi temp2,ZaLCDBegHMax
		brne EndeTimerLCDBeg 							;um mit ZhlerMax vergleichen
		
		lds temp1,SSBitByte1
		cbr temp1,1<<BitLCDBegOn				;Zhler = ZhlerMax
 		sts SSBitByte1,temp1

EndeTimerLCDBeg: 		
 		ret


;*********************************************************************************************



IstTasteGedr:
		lds temp1,SSTastenOld
		in temp2,PINB
		in temp3,PINC
		
		ldi temp4,0xFF
		           	
		
		sbrc temp2,PinTaPfUn                  ;PfUn
		cbr temp4,1<<BitTaPfUn
		sbrs temp1,BitTaPfUn
		cbr temp4,1<<BitTaPfUn
	   			
		sbrc temp2,PinTaPfOb                  ;PfOb
		cbr temp4,1<<BitTaPfOb		
		sbrs temp1,BitTaPfOb
		cbr temp4,1<<BitTaPfOb
		
		
		sbrc temp2,PinTaPfLi                  ;PfLi
		cbr temp4,1<<BitTaPfLi
		sbrs temp1,BitTaPfLi
		cbr temp4,1<<BitTaPfLi
		
		
		sbrc temp2,PinTaPfRe                  ;PfRe
		cbr temp4,1<<BitTaPfRe
		sbrs temp1,BitTaPfRe
		cbr temp4,1<<BitTaPfRe
		
		
	
		sbrc temp3,PinTaOK                  ;OK
		cbr temp4,1<<BitTaOK
		sbrs temp1,BitTaOK
		cbr temp4,1<<BitTaOK
				
		
		andi temp2,0b11111100               ;neue Werte in SSTastenOld speichern
		sbrc temp3,PinTaOK
		sbr temp2,1<<BitTaOK
		sts SSTastenOld,temp2
		
		sts SSTasten,temp4
		
		ret

;*********************************************************************************************




EEPROMDatLaden:		
		ldi temp1,0xAC
		ldi zl,low(0x0150)
		ldi zh,high(0x0150)
EEPROMDatLadenNF:
		out EEARL,zl
		out EEARH,zh
		sbi EECR,EERE
		in temp2,EEDR
		st Z+,temp2
		dec temp1
		brne EEPROMDatLadenNF
		ret


;*********************************************************************************************



EEDat0Spei:
		sbic EECR,EEWE
		rjmp EEDat0Spei
		
		lds yl,SSAdrEE0L
		lds yh,SSAdrEE0H
		out EEARL,yl
		out EEARH,yh
		ld temp1,y		
		out EEDR,temp1
		sbi EECR,EEMWE
		sbi EECR,EEWE
		ret


;*********************************************************************************************

EEDat1Spei:
		sbic EECR,EEWE
		rjmp EEDat1Spei
		
		lds yl,SSAdrEE1L
		lds yh,SSAdrEE1H
		out EEARL,yl		
		out EEARH,yh				
		ld temp1,y
		out EEDR,temp1
		sbi EECR,EEMWE
		sbi EECR,EEWE
		sbi EECR,EERIE
		ret

;*******************************************************************************************

PowerDown:
		clr temp1
		out TCCR0,temp1                         ;Timer0 stopped
		cbi UCSRB,(RXEN|TXEN)
		
		sei
		in temp1,MCUCR
		sbr temp1,1<<SE
		out MCUCR,temp1
		sleep

;*******************************************************************************************

ClearInt:
		push temp1
		in temp1,TIMSK
      sts SSTIMSK,temp1
      cbr temp1,(1<<TOIE0|1<<TOIE2)
      out TIMSK,temp1
      in temp1,UCSRB
      sts SSUCSRB,temp1
      cbr temp1,(1<<RXCIE|1<<TXCIE)
      out UCSRB,temp1
      in temp1,ADCSR
      sts SSADCSR,temp1
      cbr temp1,1<<ADIE
      out ADCSR,temp1
      pop temp1
      ret

;*******************************************************************************************

SetInt:
		push temp1
		
		in temp1,TIFR
		sbr temp1,1<<TOV0
		out TIFR,temp1		
		lds temp1,SSTIMSK
		out TIMSK,temp1
		
		
		sbi UCSRA,RXC
		sbi UCSRA,TXC		
		lds temp1,SSUCSRB
		out UCSRB,temp1
		
		
		lds temp1,SSADCSR
		out ADCSR,temp1
		pop temp1
		
      ret

;*****************************************************************************************
















